/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of Phidget22.jar
 *
 * Copyright 2017 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

package com.phidget22;
import java.util.*;

public class PHSensorBase extends Phidget {

	PHSensorBase(long handle) {
		super(handle);
	}

	public PHSensorBase() throws PhidgetException {
		super(create());
	}

	private native static long create() throws PhidgetException;

	private final void setDeviceEvents(boolean enable) {
		enablePHChangeEvents(enable && PHChangeListeners.size() > 0);
	}

	public final void addPHChangeListener(PHSensorPHChangeListener l) {
		synchronized(PHChangeListeners) {
			PHChangeListeners.add(l);
			enablePHChangeEvents(true);
		}
	}
	private List<PHSensorPHChangeListener> PHChangeListeners = new ArrayList<PHSensorPHChangeListener>();
	private long nativePHChangeHandler = 0;
	public final void removePHChangeListener(PHSensorPHChangeListener l) {
		synchronized(PHChangeListeners) {
			PHChangeListeners.remove(l);
			enablePHChangeEvents(PHChangeListeners.size() > 0);
		}
	}
	private void firePHChange(PHSensorPHChangeEvent e) {
		synchronized(PHChangeListeners) {
			for (Iterator it = PHChangeListeners.iterator (); it.hasNext();)
			((PHSensorPHChangeListener) it.next ()).onPHChange (e);
		}
	}
	private native void enablePHChangeEvents(boolean b);


	public native double getCorrectionTemperature() throws PhidgetException;
	public native void setCorrectionTemperature(double CorrectionTemperature) throws PhidgetException;
	public native double getMinCorrectionTemperature() throws PhidgetException;
	public native double getMaxCorrectionTemperature() throws PhidgetException;
	public native int getDataInterval() throws PhidgetException;
	public native void setDataInterval(int DataInterval) throws PhidgetException;
	public native int getMinDataInterval() throws PhidgetException;
	public native int getMaxDataInterval() throws PhidgetException;
	public native double getPH() throws PhidgetException;
	public native double getMinPH() throws PhidgetException;
	public native double getMaxPH() throws PhidgetException;
	public native double getPHChangeTrigger() throws PhidgetException;
	public native void setPHChangeTrigger(double PHChangeTrigger) throws PhidgetException;
	public native double getMinPHChangeTrigger() throws PhidgetException;
	public native double getMaxPHChangeTrigger() throws PhidgetException;
}
