/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of Phidget22.jar
 *
 * Copyright 2017 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

package com.phidget22;
import java.util.*;

public class PressureSensorBase extends Phidget {

	PressureSensorBase(long handle) {
		super(handle);
	}

	public PressureSensorBase() throws PhidgetException {
		super(create());
	}

	private native static long create() throws PhidgetException;

	private final void setDeviceEvents(boolean enable) {
		enablePressureChangeEvents(enable && pressureChangeListeners.size() > 0);
	}

	public final void addPressureChangeListener(PressureSensorPressureChangeListener l) {
		synchronized(pressureChangeListeners) {
			pressureChangeListeners.add(l);
			enablePressureChangeEvents(true);
		}
	}
	private List<PressureSensorPressureChangeListener> pressureChangeListeners = new ArrayList<PressureSensorPressureChangeListener>();
	private long nativePressureChangeHandler = 0;
	public final void removePressureChangeListener(PressureSensorPressureChangeListener l) {
		synchronized(pressureChangeListeners) {
			pressureChangeListeners.remove(l);
			enablePressureChangeEvents(pressureChangeListeners.size() > 0);
		}
	}
	private void firePressureChange(PressureSensorPressureChangeEvent e) {
		synchronized(pressureChangeListeners) {
			for (Iterator it = pressureChangeListeners.iterator (); it.hasNext();)
			((PressureSensorPressureChangeListener) it.next ()).onPressureChange (e);
		}
	}
	private native void enablePressureChangeEvents(boolean b);


	public native int getDataInterval() throws PhidgetException;
	public native void setDataInterval(int DataInterval) throws PhidgetException;
	public native int getMinDataInterval() throws PhidgetException;
	public native int getMaxDataInterval() throws PhidgetException;
	public native double getPressure() throws PhidgetException;
	public native double getMinPressure() throws PhidgetException;
	public native double getMaxPressure() throws PhidgetException;
	public native double getPressureChangeTrigger() throws PhidgetException;
	public native void setPressureChangeTrigger(double PressureChangeTrigger) throws PhidgetException;
	public native double getMinPressureChangeTrigger() throws PhidgetException;
	public native double getMaxPressureChangeTrigger() throws PhidgetException;
}
