/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2017 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_CapacitiveTouch.h"
#include "com_phidget22_CapacitiveTouchBase.h"

static jclass capacitiveTouchbase_class;
jclass capacitiveTouch_class;
jmethodID capacitiveTouch_cons;

static jclass touchEvent_class;
static jmethodID fireTouch_mid	;
static jmethodID touchEvent_cons;
static jfieldID nativeTouchHandler_fid;

static jclass touchEndEvent_class;
static jmethodID fireTouchEnd_mid	;
static jmethodID touchEndEvent_cons;
static jfieldID nativeTouchEndHandler_fid;

void com_phidget22_CapacitiveTouchBase_OnLoad(JNIEnv *env) {
	if (!(capacitiveTouch_class = (*env)->FindClass(env, "com/phidget22/CapacitiveTouch")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/CapacitiveTouch");
	if (!(capacitiveTouch_class = (jclass)(*env)->NewGlobalRef(env, capacitiveTouch_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef capacitiveTouch_class");
	if (!(capacitiveTouch_cons = (*env)->GetMethodID(env, capacitiveTouch_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from capacitiveTouch_class");

	if (!(capacitiveTouchbase_class = (*env)->FindClass(env, "com/phidget22/CapacitiveTouchBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/CapacitiveTouchBase");
	if (!(capacitiveTouchbase_class = (jclass)(*env)->NewGlobalRef(env, capacitiveTouchbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef capacitiveTouchbase_class");

	if (!(touchEvent_class = (*env)->FindClass(env, "com/phidget22/CapacitiveTouchTouchEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/CapacitiveTouchTouchEvent");
	if (!(touchEvent_class = (jclass)(*env)->NewGlobalRef(env, touchEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref TouchEvent_class");
	if (!(fireTouch_mid = (*env)->GetMethodID(env, capacitiveTouchbase_class, "fireTouch", "(Lcom/phidget22/CapacitiveTouchTouchEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID fireTouch");
	if (!(touchEvent_cons = (*env)->GetMethodID(env, touchEvent_class, "<init>", "(Lcom/phidget22/CapacitiveTouch;D)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from TouchEvent_class");
	if (!(nativeTouchHandler_fid = (*env)->GetFieldID(env, capacitiveTouchbase_class, "nativeTouchHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativeTouchHandler from capacitiveTouchbase_class");

	if (!(touchEndEvent_class = (*env)->FindClass(env, "com/phidget22/CapacitiveTouchTouchEndEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/CapacitiveTouchTouchEndEvent");
	if (!(touchEndEvent_class = (jclass)(*env)->NewGlobalRef(env, touchEndEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref TouchEndEvent_class");
	if (!(fireTouchEnd_mid = (*env)->GetMethodID(env, capacitiveTouchbase_class, "fireTouchEnd", "(Lcom/phidget22/CapacitiveTouchTouchEndEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID fireTouchEnd");
	if (!(touchEndEvent_cons = (*env)->GetMethodID(env, touchEndEvent_class, "<init>", "(Lcom/phidget22/CapacitiveTouch;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from TouchEndEvent_class");
	if (!(nativeTouchEndHandler_fid = (*env)->GetFieldID(env, capacitiveTouchbase_class, "nativeTouchEndHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativeTouchEndHandler from capacitiveTouchbase_class");
}
JNIEXPORT jlong JNICALL Java_com_phidget22_CapacitiveTouchBase_create(JNIEnv * env, jclass obj) {
	PhidgetCapacitiveTouchHandle phid;
	int error; 
	if ((error = PhidgetCapacitiveTouch_create(&phid)) != EPHIDGET_OK) {
		PH_THROW(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jint JNICALL Java_com_phidget22_CapacitiveTouchBase_getDataInterval(JNIEnv * env, jobject obj) {
	PhidgetCapacitiveTouchHandle h = (PhidgetCapacitiveTouchHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t dataInterval;
	ret = PhidgetCapacitiveTouch_getDataInterval(h, &dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return dataInterval;
	}
	return dataInterval;
}

JNIEXPORT void JNICALL Java_com_phidget22_CapacitiveTouchBase_setDataInterval(JNIEnv * env, jobject obj, jint dataInterval) {
	PhidgetCapacitiveTouchHandle h = (PhidgetCapacitiveTouchHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetCapacitiveTouch_setDataInterval(h, (uint32_t)dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_CapacitiveTouchBase_getMinDataInterval(JNIEnv * env, jobject obj) {
	PhidgetCapacitiveTouchHandle h = (PhidgetCapacitiveTouchHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t minDataInterval;
	ret = PhidgetCapacitiveTouch_getMinDataInterval(h, &minDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return minDataInterval;
	}
	return minDataInterval;
}

JNIEXPORT jint JNICALL Java_com_phidget22_CapacitiveTouchBase_getMaxDataInterval(JNIEnv * env, jobject obj) {
	PhidgetCapacitiveTouchHandle h = (PhidgetCapacitiveTouchHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t maxDataInterval;
	ret = PhidgetCapacitiveTouch_getMaxDataInterval(h, &maxDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return maxDataInterval;
	}
	return maxDataInterval;
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_CapacitiveTouchBase_getIsTouched(JNIEnv * env, jobject obj) {
	PhidgetCapacitiveTouchHandle h = (PhidgetCapacitiveTouchHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int isTouched;
	ret = PhidgetCapacitiveTouch_getIsTouched(h, &isTouched);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return isTouched;
	}
	return isTouched;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_CapacitiveTouchBase_getSensitivity(JNIEnv * env, jobject obj) {
	PhidgetCapacitiveTouchHandle h = (PhidgetCapacitiveTouchHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double sensitivity;
	ret = PhidgetCapacitiveTouch_getSensitivity(h, &sensitivity);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return sensitivity;
	}
	return sensitivity;
}

JNIEXPORT void JNICALL Java_com_phidget22_CapacitiveTouchBase_setSensitivity(JNIEnv * env, jobject obj, jdouble sensitivity) {
	PhidgetCapacitiveTouchHandle h = (PhidgetCapacitiveTouchHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetCapacitiveTouch_setSensitivity(h, (double)sensitivity);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_CapacitiveTouchBase_getMinSensitivity(JNIEnv * env, jobject obj) {
	PhidgetCapacitiveTouchHandle h = (PhidgetCapacitiveTouchHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minSensitivity;
	ret = PhidgetCapacitiveTouch_getMinSensitivity(h, &minSensitivity);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return minSensitivity;
	}
	return minSensitivity;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_CapacitiveTouchBase_getMaxSensitivity(JNIEnv * env, jobject obj) {
	PhidgetCapacitiveTouchHandle h = (PhidgetCapacitiveTouchHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxSensitivity;
	ret = PhidgetCapacitiveTouch_getMaxSensitivity(h, &maxSensitivity);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return maxSensitivity;
	}
	return maxSensitivity;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_CapacitiveTouchBase_getTouchValue(JNIEnv * env, jobject obj) {
	PhidgetCapacitiveTouchHandle h = (PhidgetCapacitiveTouchHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double touchValue;
	ret = PhidgetCapacitiveTouch_getTouchValue(h, &touchValue);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return touchValue;
	}
	return touchValue;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_CapacitiveTouchBase_getMinTouchValue(JNIEnv * env, jobject obj) {
	PhidgetCapacitiveTouchHandle h = (PhidgetCapacitiveTouchHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minTouchValue;
	ret = PhidgetCapacitiveTouch_getMinTouchValue(h, &minTouchValue);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return minTouchValue;
	}
	return minTouchValue;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_CapacitiveTouchBase_getMaxTouchValue(JNIEnv * env, jobject obj) {
	PhidgetCapacitiveTouchHandle h = (PhidgetCapacitiveTouchHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxTouchValue;
	ret = PhidgetCapacitiveTouch_getMaxTouchValue(h, &maxTouchValue);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return maxTouchValue;
	}
	return maxTouchValue;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_CapacitiveTouchBase_getTouchValueChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetCapacitiveTouchHandle h = (PhidgetCapacitiveTouchHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double touchValueChangeTrigger;
	ret = PhidgetCapacitiveTouch_getTouchValueChangeTrigger(h, &touchValueChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return touchValueChangeTrigger;
	}
	return touchValueChangeTrigger;
}

JNIEXPORT void JNICALL Java_com_phidget22_CapacitiveTouchBase_setTouchValueChangeTrigger(JNIEnv * env, jobject obj, jdouble touchValueChangeTrigger) {
	PhidgetCapacitiveTouchHandle h = (PhidgetCapacitiveTouchHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetCapacitiveTouch_setTouchValueChangeTrigger(h, (double)touchValueChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_CapacitiveTouchBase_getMinTouchValueChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetCapacitiveTouchHandle h = (PhidgetCapacitiveTouchHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minTouchValueChangeTrigger;
	ret = PhidgetCapacitiveTouch_getMinTouchValueChangeTrigger(h, &minTouchValueChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return minTouchValueChangeTrigger;
	}
	return minTouchValueChangeTrigger;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_CapacitiveTouchBase_getMaxTouchValueChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetCapacitiveTouchHandle h = (PhidgetCapacitiveTouchHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxTouchValueChangeTrigger;
	ret = PhidgetCapacitiveTouch_getMaxTouchValueChangeTrigger(h, &maxTouchValueChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return maxTouchValueChangeTrigger;
	}
	return maxTouchValueChangeTrigger;
}

static void CCONV touch_handler(PhidgetCapacitiveTouchHandle h, void *arg, double touchValue) {
	jobject touchEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((touchEv = (*env)->NewObject(env, touchEvent_class, touchEvent_cons, obj, touchValue)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireTouch_mid, touchEv);
		(*env)->DeleteLocalRef(env, touchEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_CapacitiveTouchBase_enableTouchEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativeTouchHandler_fid, b);
	PhidgetCapacitiveTouchHandle h = (PhidgetCapacitiveTouchHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetCapacitiveTouch_setOnTouchHandler(h, b ? touch_handler : NULL, (void *)(uintptr_t) gr);
}

static void CCONV touchEnd_handler(PhidgetCapacitiveTouchHandle h, void *arg) {
	jobject touchEndEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((touchEndEv = (*env)->NewObject(env, touchEndEvent_class, touchEndEvent_cons, obj)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireTouchEnd_mid, touchEndEv);
		(*env)->DeleteLocalRef(env, touchEndEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_CapacitiveTouchBase_enableTouchEndEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativeTouchEndHandler_fid, b);
	PhidgetCapacitiveTouchHandle h = (PhidgetCapacitiveTouchHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetCapacitiveTouch_setOnTouchEndHandler(h, b ? touchEnd_handler : NULL, (void *)(uintptr_t) gr);
}
