/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2017 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_DataAdapter.h"
#include "com_phidget22_DataAdapterBase.h"

static jclass dataAdapterbase_class;
jclass dataAdapter_class;
jmethodID dataAdapter_cons;

static jclass packetEvent_class;
static jmethodID firePacket_mid	;
static jmethodID packetEvent_cons;
static jfieldID nativePacketHandler_fid;

void com_phidget22_DataAdapterBase_OnLoad(JNIEnv *env) {
	if (!(dataAdapter_class = (*env)->FindClass(env, "com/phidget22/DataAdapter")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/DataAdapter");
	if (!(dataAdapter_class = (jclass)(*env)->NewGlobalRef(env, dataAdapter_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef dataAdapter_class");
	if (!(dataAdapter_cons = (*env)->GetMethodID(env, dataAdapter_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from dataAdapter_class");

	if (!(dataAdapterbase_class = (*env)->FindClass(env, "com/phidget22/DataAdapterBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/DataAdapterBase");
	if (!(dataAdapterbase_class = (jclass)(*env)->NewGlobalRef(env, dataAdapterbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef dataAdapterbase_class");

	if (!(packetEvent_class = (*env)->FindClass(env, "com/phidget22/DataAdapterPacketEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/DataAdapterPacketEvent");
	if (!(packetEvent_class = (jclass)(*env)->NewGlobalRef(env, packetEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref PacketEvent_class");
	if (!(firePacket_mid = (*env)->GetMethodID(env, dataAdapterbase_class, "firePacket", "(Lcom/phidget22/DataAdapterPacketEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID firePacket");
	if (!(packetEvent_cons = (*env)->GetMethodID(env, packetEvent_class, "<init>", "(Lcom/phidget22/DataAdapter;[BZ)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from PacketEvent_class");
	if (!(nativePacketHandler_fid = (*env)->GetFieldID(env, dataAdapterbase_class, "nativePacketHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativePacketHandler from dataAdapterbase_class");
}
JNIEXPORT jlong JNICALL Java_com_phidget22_DataAdapterBase_create(JNIEnv * env, jclass obj) {
	PhidgetDataAdapterHandle phid;
	int error; 
	if ((error = PhidgetDataAdapter_create(&phid)) != EPHIDGET_OK) {
		PH_THROW(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jint JNICALL Java_com_phidget22_DataAdapterBase_getMaxPacketLength(JNIEnv * env, jobject obj) {
	PhidgetDataAdapterHandle h = (PhidgetDataAdapterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t maxPacketLength;
	ret = PhidgetDataAdapter_getMaxPacketLength(h, &maxPacketLength);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return maxPacketLength;
	}
	return maxPacketLength;
}

JNIEXPORT void JNICALL Java_com_phidget22_DataAdapterBase_sendPacket___3B(JNIEnv * env, jobject obj, jbyteArray data) {
	PhidgetDataAdapterHandle h = (PhidgetDataAdapterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint8_t *dataArr = (*env)->GetByteArrayElements(env, data, 0);
	size_t dataLen = (*env)->GetArrayLength(env, data);
	ret = PhidgetDataAdapter_sendPacket(h, dataArr, (size_t)dataLen);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		(*env)->ReleaseByteArrayElements(env, data, dataArr, 0);
		return;
	}
	(*env)->ReleaseByteArrayElements(env, data, dataArr, 0);
}

JNIEXPORT void JNICALL Java_com_phidget22_DataAdapterBase_sendPacket___3BLcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jbyteArray data, jobject asyncHandler) {
	PhidgetDataAdapterHandle h = (PhidgetDataAdapterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	uint8_t *dataArr = (*env)->GetByteArrayElements(env, data, 0);
	size_t dataLen = (*env)->GetArrayLength(env, data);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, (*env)->NewGlobalRef(env, obj));
	(*env)->SetObjectArrayElement(env, arr, 1, (*env)->NewGlobalRef(env, asyncHandler));
	PhidgetDataAdapter_sendPacket_async(h, dataArr, (size_t)dataLen, asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
	(*env)->DeleteLocalRef(env, arr);
	(*env)->ReleaseByteArrayElements(env, data, dataArr, 0);
}

static void CCONV packet_handler(PhidgetDataAdapterHandle h, void *arg, const uint8_t *data, size_t dataLen, int overrun) {
	jobject packetEv;
	JNIEnv *env;
	jobject obj;
	jbyteArray dataArr;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;
	dataArr = (*env)->NewByteArray(env, (jsize)dataLen);
	(*env)->SetByteArrayRegion(env, dataArr, 0, (jsize)dataLen, data);

	if ((packetEv = (*env)->NewObject(env, packetEvent_class, packetEvent_cons, obj, dataArr, overrun)) != 0) {
		(*env)->CallVoidMethod(env, obj, firePacket_mid, packetEv);
		(*env)->DeleteLocalRef(env, packetEv);
	}
	(*env)->DeleteLocalRef(env, dataArr);
}

JNIEXPORT void JNICALL Java_com_phidget22_DataAdapterBase_enablePacketEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativePacketHandler_fid, b);
	PhidgetDataAdapterHandle h = (PhidgetDataAdapterHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetDataAdapter_setOnPacketHandler(h, b ? packet_handler : NULL, (void *)(uintptr_t) gr);
}
