/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2017 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_GPS.h"
#include "com_phidget22_GPSBase.h"

static jclass GPSbase_class;
jclass GPS_class;
jmethodID GPS_cons;

static jclass positionChangeEvent_class;
static jmethodID firePositionChange_mid	;
static jmethodID positionChangeEvent_cons;
static jfieldID nativePositionChangeHandler_fid;

static jclass headingChangeEvent_class;
static jmethodID fireHeadingChange_mid	;
static jmethodID headingChangeEvent_cons;
static jfieldID nativeHeadingChangeHandler_fid;

static jclass positionFixStateChangeEvent_class;
static jmethodID firePositionFixStateChange_mid	;
static jmethodID positionFixStateChangeEvent_cons;
static jfieldID nativePositionFixStateChangeHandler_fid;

void com_phidget22_GPSBase_OnLoad(JNIEnv *env) {
	if (!(GPS_class = (*env)->FindClass(env, "com/phidget22/GPS")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/GPS");
	if (!(GPS_class = (jclass)(*env)->NewGlobalRef(env, GPS_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef GPS_class");
	if (!(GPS_cons = (*env)->GetMethodID(env, GPS_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from GPS_class");

	if (!(GPSbase_class = (*env)->FindClass(env, "com/phidget22/GPSBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/GPSBase");
	if (!(GPSbase_class = (jclass)(*env)->NewGlobalRef(env, GPSbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef GPSbase_class");

	if (!(positionChangeEvent_class = (*env)->FindClass(env, "com/phidget22/GPSPositionChangeEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/GPSPositionChangeEvent");
	if (!(positionChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, positionChangeEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref PositionChangeEvent_class");
	if (!(firePositionChange_mid = (*env)->GetMethodID(env, GPSbase_class, "firePositionChange", "(Lcom/phidget22/GPSPositionChangeEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID firePositionChange");
	if (!(positionChangeEvent_cons = (*env)->GetMethodID(env, positionChangeEvent_class, "<init>", "(Lcom/phidget22/GPS;DDD)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from PositionChangeEvent_class");
	if (!(nativePositionChangeHandler_fid = (*env)->GetFieldID(env, GPSbase_class, "nativePositionChangeHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativePositionChangeHandler from GPSbase_class");

	if (!(headingChangeEvent_class = (*env)->FindClass(env, "com/phidget22/GPSHeadingChangeEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/GPSHeadingChangeEvent");
	if (!(headingChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, headingChangeEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref HeadingChangeEvent_class");
	if (!(fireHeadingChange_mid = (*env)->GetMethodID(env, GPSbase_class, "fireHeadingChange", "(Lcom/phidget22/GPSHeadingChangeEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID fireHeadingChange");
	if (!(headingChangeEvent_cons = (*env)->GetMethodID(env, headingChangeEvent_class, "<init>", "(Lcom/phidget22/GPS;DD)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from HeadingChangeEvent_class");
	if (!(nativeHeadingChangeHandler_fid = (*env)->GetFieldID(env, GPSbase_class, "nativeHeadingChangeHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativeHeadingChangeHandler from GPSbase_class");

	if (!(positionFixStateChangeEvent_class = (*env)->FindClass(env, "com/phidget22/GPSPositionFixStateChangeEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/GPSPositionFixStateChangeEvent");
	if (!(positionFixStateChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, positionFixStateChangeEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref PositionFixStateChangeEvent_class");
	if (!(firePositionFixStateChange_mid = (*env)->GetMethodID(env, GPSbase_class, "firePositionFixStateChange", "(Lcom/phidget22/GPSPositionFixStateChangeEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID firePositionFixStateChange");
	if (!(positionFixStateChangeEvent_cons = (*env)->GetMethodID(env, positionFixStateChangeEvent_class, "<init>", "(Lcom/phidget22/GPS;Z)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from PositionFixStateChangeEvent_class");
	if (!(nativePositionFixStateChangeHandler_fid = (*env)->GetFieldID(env, GPSbase_class, "nativePositionFixStateChangeHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativePositionFixStateChangeHandler from GPSbase_class");
}
JNIEXPORT jlong JNICALL Java_com_phidget22_GPSBase_create(JNIEnv * env, jclass obj) {
	PhidgetGPSHandle phid;
	int error; 
	if ((error = PhidgetGPS_create(&phid)) != EPHIDGET_OK) {
		PH_THROW(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_GPSBase_getAltitude(JNIEnv * env, jobject obj) {
	PhidgetGPSHandle h = (PhidgetGPSHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double altitude;
	ret = PhidgetGPS_getAltitude(h, &altitude);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return altitude;
	}
	return altitude;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_GPSBase_getDate(JNIEnv * env, jobject obj) {
	PhidgetGPSHandle h = (PhidgetGPSHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	PhidgetGPS_Date date;
	ret = PhidgetGPS_getDate(h, &date);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return NULL;
	}
	return PhidgetGPS_Date_to_jobject(env, &date);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_GPSBase_getHeading(JNIEnv * env, jobject obj) {
	PhidgetGPSHandle h = (PhidgetGPSHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double heading;
	ret = PhidgetGPS_getHeading(h, &heading);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return heading;
	}
	return heading;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_GPSBase_getLatitude(JNIEnv * env, jobject obj) {
	PhidgetGPSHandle h = (PhidgetGPSHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double latitude;
	ret = PhidgetGPS_getLatitude(h, &latitude);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return latitude;
	}
	return latitude;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_GPSBase_getLongitude(JNIEnv * env, jobject obj) {
	PhidgetGPSHandle h = (PhidgetGPSHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double longitude;
	ret = PhidgetGPS_getLongitude(h, &longitude);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return longitude;
	}
	return longitude;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_GPSBase_getNMEAData(JNIEnv * env, jobject obj) {
	PhidgetGPSHandle h = (PhidgetGPSHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	PhidgetGPS_NMEAData NMEAData;
	ret = PhidgetGPS_getNMEAData(h, &NMEAData);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return NULL;
	}
	return PhidgetGPS_NMEAData_to_jobject(env, &NMEAData);
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_GPSBase_getPositionFixState(JNIEnv * env, jobject obj) {
	PhidgetGPSHandle h = (PhidgetGPSHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int positionFixState;
	ret = PhidgetGPS_getPositionFixState(h, &positionFixState);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return positionFixState;
	}
	return positionFixState;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_GPSBase_getTime(JNIEnv * env, jobject obj) {
	PhidgetGPSHandle h = (PhidgetGPSHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	PhidgetGPS_Time time;
	ret = PhidgetGPS_getTime(h, &time);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return NULL;
	}
	return PhidgetGPS_Time_to_jobject(env, &time);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_GPSBase_getVelocity(JNIEnv * env, jobject obj) {
	PhidgetGPSHandle h = (PhidgetGPSHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double velocity;
	ret = PhidgetGPS_getVelocity(h, &velocity);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return velocity;
	}
	return velocity;
}

static void CCONV headingChange_handler(PhidgetGPSHandle h, void *arg, double heading, double velocity) {
	jobject headingChangeEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((headingChangeEv = (*env)->NewObject(env, headingChangeEvent_class, headingChangeEvent_cons, obj, heading, velocity)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireHeadingChange_mid, headingChangeEv);
		(*env)->DeleteLocalRef(env, headingChangeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_GPSBase_enableHeadingChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativeHeadingChangeHandler_fid, b);
	PhidgetGPSHandle h = (PhidgetGPSHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetGPS_setOnHeadingChangeHandler(h, b ? headingChange_handler : NULL, (void *)(uintptr_t) gr);
}

static void CCONV positionChange_handler(PhidgetGPSHandle h, void *arg, double latitude, double longitude, double altitude) {
	jobject positionChangeEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((positionChangeEv = (*env)->NewObject(env, positionChangeEvent_class, positionChangeEvent_cons, obj, latitude, longitude, altitude)) != 0) {
		(*env)->CallVoidMethod(env, obj, firePositionChange_mid, positionChangeEv);
		(*env)->DeleteLocalRef(env, positionChangeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_GPSBase_enablePositionChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativePositionChangeHandler_fid, b);
	PhidgetGPSHandle h = (PhidgetGPSHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetGPS_setOnPositionChangeHandler(h, b ? positionChange_handler : NULL, (void *)(uintptr_t) gr);
}

static void CCONV positionFixStateChange_handler(PhidgetGPSHandle h, void *arg, int positionFixState) {
	jobject positionFixStateChangeEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((positionFixStateChangeEv = (*env)->NewObject(env, positionFixStateChangeEvent_class, positionFixStateChangeEvent_cons, obj, positionFixState)) != 0) {
		(*env)->CallVoidMethod(env, obj, firePositionFixStateChange_mid, positionFixStateChangeEv);
		(*env)->DeleteLocalRef(env, positionFixStateChangeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_GPSBase_enablePositionFixStateChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativePositionFixStateChangeHandler_fid, b);
	PhidgetGPSHandle h = (PhidgetGPSHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetGPS_setOnPositionFixStateChangeHandler(h, b ? positionFixStateChange_handler : NULL, (void *)(uintptr_t) gr);
}
