/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2017 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_HumiditySensor.h"
#include "com_phidget22_HumiditySensorBase.h"

static jclass humiditySensorbase_class;
jclass humiditySensor_class;
jmethodID humiditySensor_cons;

static jclass humidityChangeEvent_class;
static jmethodID fireHumidityChange_mid	;
static jmethodID humidityChangeEvent_cons;
static jfieldID nativeHumidityChangeHandler_fid;

void com_phidget22_HumiditySensorBase_OnLoad(JNIEnv *env) {
	if (!(humiditySensor_class = (*env)->FindClass(env, "com/phidget22/HumiditySensor")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/HumiditySensor");
	if (!(humiditySensor_class = (jclass)(*env)->NewGlobalRef(env, humiditySensor_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef humiditySensor_class");
	if (!(humiditySensor_cons = (*env)->GetMethodID(env, humiditySensor_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from humiditySensor_class");

	if (!(humiditySensorbase_class = (*env)->FindClass(env, "com/phidget22/HumiditySensorBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/HumiditySensorBase");
	if (!(humiditySensorbase_class = (jclass)(*env)->NewGlobalRef(env, humiditySensorbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef humiditySensorbase_class");

	if (!(humidityChangeEvent_class = (*env)->FindClass(env, "com/phidget22/HumiditySensorHumidityChangeEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/HumiditySensorHumidityChangeEvent");
	if (!(humidityChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, humidityChangeEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref HumidityChangeEvent_class");
	if (!(fireHumidityChange_mid = (*env)->GetMethodID(env, humiditySensorbase_class, "fireHumidityChange", "(Lcom/phidget22/HumiditySensorHumidityChangeEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID fireHumidityChange");
	if (!(humidityChangeEvent_cons = (*env)->GetMethodID(env, humidityChangeEvent_class, "<init>", "(Lcom/phidget22/HumiditySensor;D)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from HumidityChangeEvent_class");
	if (!(nativeHumidityChangeHandler_fid = (*env)->GetFieldID(env, humiditySensorbase_class, "nativeHumidityChangeHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativeHumidityChangeHandler from humiditySensorbase_class");
}
JNIEXPORT jlong JNICALL Java_com_phidget22_HumiditySensorBase_create(JNIEnv * env, jclass obj) {
	PhidgetHumiditySensorHandle phid;
	int error; 
	if ((error = PhidgetHumiditySensor_create(&phid)) != EPHIDGET_OK) {
		PH_THROW(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jint JNICALL Java_com_phidget22_HumiditySensorBase_getDataInterval(JNIEnv * env, jobject obj) {
	PhidgetHumiditySensorHandle h = (PhidgetHumiditySensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t dataInterval;
	ret = PhidgetHumiditySensor_getDataInterval(h, &dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return dataInterval;
	}
	return dataInterval;
}

JNIEXPORT void JNICALL Java_com_phidget22_HumiditySensorBase_setDataInterval(JNIEnv * env, jobject obj, jint dataInterval) {
	PhidgetHumiditySensorHandle h = (PhidgetHumiditySensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetHumiditySensor_setDataInterval(h, (uint32_t)dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_HumiditySensorBase_getMinDataInterval(JNIEnv * env, jobject obj) {
	PhidgetHumiditySensorHandle h = (PhidgetHumiditySensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t minDataInterval;
	ret = PhidgetHumiditySensor_getMinDataInterval(h, &minDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return minDataInterval;
	}
	return minDataInterval;
}

JNIEXPORT jint JNICALL Java_com_phidget22_HumiditySensorBase_getMaxDataInterval(JNIEnv * env, jobject obj) {
	PhidgetHumiditySensorHandle h = (PhidgetHumiditySensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t maxDataInterval;
	ret = PhidgetHumiditySensor_getMaxDataInterval(h, &maxDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return maxDataInterval;
	}
	return maxDataInterval;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_HumiditySensorBase_getHumidity(JNIEnv * env, jobject obj) {
	PhidgetHumiditySensorHandle h = (PhidgetHumiditySensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double humidity;
	ret = PhidgetHumiditySensor_getHumidity(h, &humidity);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return humidity;
	}
	return humidity;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_HumiditySensorBase_getMinHumidity(JNIEnv * env, jobject obj) {
	PhidgetHumiditySensorHandle h = (PhidgetHumiditySensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minHumidity;
	ret = PhidgetHumiditySensor_getMinHumidity(h, &minHumidity);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return minHumidity;
	}
	return minHumidity;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_HumiditySensorBase_getMaxHumidity(JNIEnv * env, jobject obj) {
	PhidgetHumiditySensorHandle h = (PhidgetHumiditySensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxHumidity;
	ret = PhidgetHumiditySensor_getMaxHumidity(h, &maxHumidity);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return maxHumidity;
	}
	return maxHumidity;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_HumiditySensorBase_getHumidityChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetHumiditySensorHandle h = (PhidgetHumiditySensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double humidityChangeTrigger;
	ret = PhidgetHumiditySensor_getHumidityChangeTrigger(h, &humidityChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return humidityChangeTrigger;
	}
	return humidityChangeTrigger;
}

JNIEXPORT void JNICALL Java_com_phidget22_HumiditySensorBase_setHumidityChangeTrigger(JNIEnv * env, jobject obj, jdouble humidityChangeTrigger) {
	PhidgetHumiditySensorHandle h = (PhidgetHumiditySensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetHumiditySensor_setHumidityChangeTrigger(h, (double)humidityChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_HumiditySensorBase_getMinHumidityChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetHumiditySensorHandle h = (PhidgetHumiditySensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minHumidityChangeTrigger;
	ret = PhidgetHumiditySensor_getMinHumidityChangeTrigger(h, &minHumidityChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return minHumidityChangeTrigger;
	}
	return minHumidityChangeTrigger;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_HumiditySensorBase_getMaxHumidityChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetHumiditySensorHandle h = (PhidgetHumiditySensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxHumidityChangeTrigger;
	ret = PhidgetHumiditySensor_getMaxHumidityChangeTrigger(h, &maxHumidityChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return maxHumidityChangeTrigger;
	}
	return maxHumidityChangeTrigger;
}

static void CCONV humidityChange_handler(PhidgetHumiditySensorHandle h, void *arg, double humidity) {
	jobject humidityChangeEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((humidityChangeEv = (*env)->NewObject(env, humidityChangeEvent_class, humidityChangeEvent_cons, obj, humidity)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireHumidityChange_mid, humidityChangeEv);
		(*env)->DeleteLocalRef(env, humidityChangeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_HumiditySensorBase_enableHumidityChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativeHumidityChangeHandler_fid, b);
	PhidgetHumiditySensorHandle h = (PhidgetHumiditySensorHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetHumiditySensor_setOnHumidityChangeHandler(h, b ? humidityChange_handler : NULL, (void *)(uintptr_t) gr);
}
