/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2017 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_Log.h"
#include "com_phidget22_LogBase.h"

static jclass logbase_class;
jclass log_class;

void com_phidget22_LogBase_OnLoad(JNIEnv *env) {
	if (!(log_class = (*env)->FindClass(env, "com/phidget22/Log")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/Log");
	if (!(log_class = (jclass)(*env)->NewGlobalRef(env, log_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef log_class");

	if (!(logbase_class = (*env)->FindClass(env, "com/phidget22/LogBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/LogBase");
	if (!(logbase_class = (jclass)(*env)->NewGlobalRef(env, logbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef logbase_class");
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_disable(JNIEnv * env, jobject obj) {
	PhidgetReturnCode ret;
	ret = PhidgetLog_disable();
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_enable(JNIEnv * env, jobject obj, jobject level, jstring destination) {
	PhidgetReturnCode ret;
	const char *destinationUTFChars = (destination == NULL ? NULL : (*env)->GetStringUTFChars(env, destination, NULL));
	ret = PhidgetLog_enable((Phidget_LogLevel)(*env)->CallIntMethod(env, level, LogLevel_getCode_mid), (const char *)destinationUTFChars);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		if (destinationUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, destination, destinationUTFChars);
		return;
	}
	if (destinationUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, destination, destinationUTFChars);
}

JNIEXPORT jobject JNICALL Java_com_phidget22_LogBase_getLevel(JNIEnv * env, jobject obj) {
	PhidgetReturnCode ret;
	Phidget_LogLevel level;
	ret = PhidgetLog_getLevel(&level);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, LogLevel_class, LogLevel_getEnum_mid, level);
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_setLevel(JNIEnv * env, jobject obj, jobject level) {
	PhidgetReturnCode ret;
	ret = PhidgetLog_setLevel((Phidget_LogLevel)(*env)->CallIntMethod(env, level, LogLevel_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_log__Lcom_phidget22_LogLevel_2Ljava_lang_String_2Ljava_lang_String_2(JNIEnv * env, jobject obj, jobject level, jstring source, jstring message) {
	PhidgetReturnCode ret;
	const char *sourceUTFChars = (source == NULL ? NULL : (*env)->GetStringUTFChars(env, source, NULL));
	const char *messageUTFChars = (message == NULL ? NULL : (*env)->GetStringUTFChars(env, message, NULL));
	ret = PhidgetLog_loges((Phidget_LogLevel)(*env)->CallIntMethod(env, level, LogLevel_getCode_mid), (const char *)sourceUTFChars, (const char *)messageUTFChars);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		if (sourceUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, source, sourceUTFChars);
		if (messageUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, message, messageUTFChars);
		return;
	}
	if (sourceUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, source, sourceUTFChars);
	if (messageUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, message, messageUTFChars);
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_log__Lcom_phidget22_LogLevel_2Ljava_lang_String_2(JNIEnv * env, jobject obj, jobject level, jstring message) {
	PhidgetReturnCode ret;
	const char *messageUTFChars = (message == NULL ? NULL : (*env)->GetStringUTFChars(env, message, NULL));
	ret = PhidgetLog_logs((Phidget_LogLevel)(*env)->CallIntMethod(env, level, LogLevel_getCode_mid), (const char *)messageUTFChars);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		if (messageUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, message, messageUTFChars);
		return;
	}
	if (messageUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, message, messageUTFChars);
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_rotate(JNIEnv * env, jobject obj) {
	PhidgetReturnCode ret;
	ret = PhidgetLog_rotate();
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return;
	}
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_LogBase_isRotating(JNIEnv * env, jobject obj) {
	PhidgetReturnCode ret;
	int isrotating;
	ret = PhidgetLog_isRotating(&isrotating);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return isrotating;
	}
	return isrotating;
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_setRotating(JNIEnv * env, jobject obj, jlong size, jint keepCount) {
	PhidgetReturnCode ret;
	ret = PhidgetLog_setRotating((uint64_t)size, (int)keepCount);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_enableRotating(JNIEnv * env, jobject obj) {
	PhidgetReturnCode ret;
	ret = PhidgetLog_enableRotating();
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_disableRotating(JNIEnv * env, jobject obj) {
	PhidgetReturnCode ret;
	ret = PhidgetLog_disableRotating();
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_addSource(JNIEnv * env, jobject obj, jstring source, jobject level) {
	PhidgetReturnCode ret;
	const char *sourceUTFChars = (source == NULL ? NULL : (*env)->GetStringUTFChars(env, source, NULL));
	ret = PhidgetLog_addSource((const char *)sourceUTFChars, (Phidget_LogLevel)(*env)->CallIntMethod(env, level, LogLevel_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		if (sourceUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, source, sourceUTFChars);
		return;
	}
	if (sourceUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, source, sourceUTFChars);
}

JNIEXPORT jobject JNICALL Java_com_phidget22_LogBase_getSourceLevel(JNIEnv * env, jobject obj, jstring source) {
	PhidgetReturnCode ret;
	const char *sourceUTFChars = (source == NULL ? NULL : (*env)->GetStringUTFChars(env, source, NULL));
	Phidget_LogLevel level;
	ret = PhidgetLog_getSourceLevel((const char *)sourceUTFChars, &level);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		if (sourceUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, source, sourceUTFChars);
		return NULL;
	}
	if (sourceUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, source, sourceUTFChars);
	return (*env)->CallStaticObjectMethod(env, LogLevel_class, LogLevel_getEnum_mid, level);
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_setSourceLevel(JNIEnv * env, jobject obj, jstring source, jobject level) {
	PhidgetReturnCode ret;
	const char *sourceUTFChars = (source == NULL ? NULL : (*env)->GetStringUTFChars(env, source, NULL));
	ret = PhidgetLog_setSourceLevel((const char *)sourceUTFChars, (Phidget_LogLevel)(*env)->CallIntMethod(env, level, LogLevel_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		if (sourceUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, source, sourceUTFChars);
		return;
	}
	if (sourceUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, source, sourceUTFChars);
}
