/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2017 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_PowerGuard.h"
#include "com_phidget22_PowerGuardBase.h"

static jclass powerGuardbase_class;
jclass powerGuard_class;
jmethodID powerGuard_cons;

void com_phidget22_PowerGuardBase_OnLoad(JNIEnv *env) {
	if (!(powerGuard_class = (*env)->FindClass(env, "com/phidget22/PowerGuard")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/PowerGuard");
	if (!(powerGuard_class = (jclass)(*env)->NewGlobalRef(env, powerGuard_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef powerGuard_class");
	if (!(powerGuard_cons = (*env)->GetMethodID(env, powerGuard_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from powerGuard_class");

	if (!(powerGuardbase_class = (*env)->FindClass(env, "com/phidget22/PowerGuardBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/PowerGuardBase");
	if (!(powerGuardbase_class = (jclass)(*env)->NewGlobalRef(env, powerGuardbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef powerGuardbase_class");
}
JNIEXPORT jlong JNICALL Java_com_phidget22_PowerGuardBase_create(JNIEnv * env, jclass obj) {
	PhidgetPowerGuardHandle phid;
	int error; 
	if ((error = PhidgetPowerGuard_create(&phid)) != EPHIDGET_OK) {
		PH_THROW(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_PowerGuardBase_getFanMode(JNIEnv * env, jobject obj) {
	PhidgetPowerGuardHandle h = (PhidgetPowerGuardHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	Phidget_FanMode fanMode;
	ret = PhidgetPowerGuard_getFanMode(h, &fanMode);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, FanMode_class, FanMode_getEnum_mid, fanMode);
}

JNIEXPORT void JNICALL Java_com_phidget22_PowerGuardBase_setFanMode(JNIEnv * env, jobject obj, jobject fanMode) {
	PhidgetPowerGuardHandle h = (PhidgetPowerGuardHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetPowerGuard_setFanMode(h, (Phidget_FanMode)(*env)->CallIntMethod(env, fanMode, FanMode_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_PowerGuardBase_getOverVoltage(JNIEnv * env, jobject obj) {
	PhidgetPowerGuardHandle h = (PhidgetPowerGuardHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double overVoltage;
	ret = PhidgetPowerGuard_getOverVoltage(h, &overVoltage);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return overVoltage;
	}
	return overVoltage;
}

JNIEXPORT void JNICALL Java_com_phidget22_PowerGuardBase_setOverVoltage(JNIEnv * env, jobject obj, jdouble overVoltage) {
	PhidgetPowerGuardHandle h = (PhidgetPowerGuardHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetPowerGuard_setOverVoltage(h, (double)overVoltage);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_PowerGuardBase_getMinOverVoltage(JNIEnv * env, jobject obj) {
	PhidgetPowerGuardHandle h = (PhidgetPowerGuardHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minOverVoltage;
	ret = PhidgetPowerGuard_getMinOverVoltage(h, &minOverVoltage);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return minOverVoltage;
	}
	return minOverVoltage;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_PowerGuardBase_getMaxOverVoltage(JNIEnv * env, jobject obj) {
	PhidgetPowerGuardHandle h = (PhidgetPowerGuardHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxOverVoltage;
	ret = PhidgetPowerGuard_getMaxOverVoltage(h, &maxOverVoltage);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return maxOverVoltage;
	}
	return maxOverVoltage;
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_PowerGuardBase_getPowerEnabled(JNIEnv * env, jobject obj) {
	PhidgetPowerGuardHandle h = (PhidgetPowerGuardHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int powerEnabled;
	ret = PhidgetPowerGuard_getPowerEnabled(h, &powerEnabled);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return powerEnabled;
	}
	return powerEnabled;
}

JNIEXPORT void JNICALL Java_com_phidget22_PowerGuardBase_setPowerEnabled(JNIEnv * env, jobject obj, jboolean powerEnabled) {
	PhidgetPowerGuardHandle h = (PhidgetPowerGuardHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetPowerGuard_setPowerEnabled(h, (int)powerEnabled);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return;
	}
}
