/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2017 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_TemperatureSensor.h"
#include "com_phidget22_TemperatureSensorBase.h"

static jclass temperatureSensorbase_class;
jclass temperatureSensor_class;
jmethodID temperatureSensor_cons;

static jclass temperatureChangeEvent_class;
static jmethodID fireTemperatureChange_mid	;
static jmethodID temperatureChangeEvent_cons;
static jfieldID nativeTemperatureChangeHandler_fid;

void com_phidget22_TemperatureSensorBase_OnLoad(JNIEnv *env) {
	if (!(temperatureSensor_class = (*env)->FindClass(env, "com/phidget22/TemperatureSensor")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/TemperatureSensor");
	if (!(temperatureSensor_class = (jclass)(*env)->NewGlobalRef(env, temperatureSensor_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef temperatureSensor_class");
	if (!(temperatureSensor_cons = (*env)->GetMethodID(env, temperatureSensor_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from temperatureSensor_class");

	if (!(temperatureSensorbase_class = (*env)->FindClass(env, "com/phidget22/TemperatureSensorBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/TemperatureSensorBase");
	if (!(temperatureSensorbase_class = (jclass)(*env)->NewGlobalRef(env, temperatureSensorbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef temperatureSensorbase_class");

	if (!(temperatureChangeEvent_class = (*env)->FindClass(env, "com/phidget22/TemperatureSensorTemperatureChangeEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/TemperatureSensorTemperatureChangeEvent");
	if (!(temperatureChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, temperatureChangeEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref TemperatureChangeEvent_class");
	if (!(fireTemperatureChange_mid = (*env)->GetMethodID(env, temperatureSensorbase_class, "fireTemperatureChange", "(Lcom/phidget22/TemperatureSensorTemperatureChangeEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID fireTemperatureChange");
	if (!(temperatureChangeEvent_cons = (*env)->GetMethodID(env, temperatureChangeEvent_class, "<init>", "(Lcom/phidget22/TemperatureSensor;D)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from TemperatureChangeEvent_class");
	if (!(nativeTemperatureChangeHandler_fid = (*env)->GetFieldID(env, temperatureSensorbase_class, "nativeTemperatureChangeHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativeTemperatureChangeHandler from temperatureSensorbase_class");
}
JNIEXPORT jlong JNICALL Java_com_phidget22_TemperatureSensorBase_create(JNIEnv * env, jclass obj) {
	PhidgetTemperatureSensorHandle phid;
	int error; 
	if ((error = PhidgetTemperatureSensor_create(&phid)) != EPHIDGET_OK) {
		PH_THROW(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jint JNICALL Java_com_phidget22_TemperatureSensorBase_getDataInterval(JNIEnv * env, jobject obj) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t dataInterval;
	ret = PhidgetTemperatureSensor_getDataInterval(h, &dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return dataInterval;
	}
	return dataInterval;
}

JNIEXPORT void JNICALL Java_com_phidget22_TemperatureSensorBase_setDataInterval(JNIEnv * env, jobject obj, jint dataInterval) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetTemperatureSensor_setDataInterval(h, (uint32_t)dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_TemperatureSensorBase_getMinDataInterval(JNIEnv * env, jobject obj) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t minDataInterval;
	ret = PhidgetTemperatureSensor_getMinDataInterval(h, &minDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return minDataInterval;
	}
	return minDataInterval;
}

JNIEXPORT jint JNICALL Java_com_phidget22_TemperatureSensorBase_getMaxDataInterval(JNIEnv * env, jobject obj) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t maxDataInterval;
	ret = PhidgetTemperatureSensor_getMaxDataInterval(h, &maxDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return maxDataInterval;
	}
	return maxDataInterval;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_TemperatureSensorBase_getRTDType(JNIEnv * env, jobject obj) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	PhidgetTemperatureSensor_RTDType RTDType;
	ret = PhidgetTemperatureSensor_getRTDType(h, &RTDType);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, RTDType_class, RTDType_getEnum_mid, RTDType);
}

JNIEXPORT void JNICALL Java_com_phidget22_TemperatureSensorBase_setRTDType(JNIEnv * env, jobject obj, jobject RTDType) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetTemperatureSensor_setRTDType(h, (PhidgetTemperatureSensor_RTDType)(*env)->CallIntMethod(env, RTDType, RTDType_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return;
	}
}

JNIEXPORT jobject JNICALL Java_com_phidget22_TemperatureSensorBase_getRTDWireSetup(JNIEnv * env, jobject obj) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	Phidget_RTDWireSetup RTDWireSetup;
	ret = PhidgetTemperatureSensor_getRTDWireSetup(h, &RTDWireSetup);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, RTDWireSetup_class, RTDWireSetup_getEnum_mid, RTDWireSetup);
}

JNIEXPORT void JNICALL Java_com_phidget22_TemperatureSensorBase_setRTDWireSetup(JNIEnv * env, jobject obj, jobject RTDWireSetup) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetTemperatureSensor_setRTDWireSetup(h, (Phidget_RTDWireSetup)(*env)->CallIntMethod(env, RTDWireSetup, RTDWireSetup_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_TemperatureSensorBase_getTemperature(JNIEnv * env, jobject obj) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double temperature;
	ret = PhidgetTemperatureSensor_getTemperature(h, &temperature);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return temperature;
	}
	return temperature;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_TemperatureSensorBase_getMinTemperature(JNIEnv * env, jobject obj) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minTemperature;
	ret = PhidgetTemperatureSensor_getMinTemperature(h, &minTemperature);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return minTemperature;
	}
	return minTemperature;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_TemperatureSensorBase_getMaxTemperature(JNIEnv * env, jobject obj) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxTemperature;
	ret = PhidgetTemperatureSensor_getMaxTemperature(h, &maxTemperature);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return maxTemperature;
	}
	return maxTemperature;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_TemperatureSensorBase_getTemperatureChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double temperatureChangeTrigger;
	ret = PhidgetTemperatureSensor_getTemperatureChangeTrigger(h, &temperatureChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return temperatureChangeTrigger;
	}
	return temperatureChangeTrigger;
}

JNIEXPORT void JNICALL Java_com_phidget22_TemperatureSensorBase_setTemperatureChangeTrigger(JNIEnv * env, jobject obj, jdouble temperatureChangeTrigger) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetTemperatureSensor_setTemperatureChangeTrigger(h, (double)temperatureChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_TemperatureSensorBase_getMinTemperatureChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minTemperatureChangeTrigger;
	ret = PhidgetTemperatureSensor_getMinTemperatureChangeTrigger(h, &minTemperatureChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return minTemperatureChangeTrigger;
	}
	return minTemperatureChangeTrigger;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_TemperatureSensorBase_getMaxTemperatureChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxTemperatureChangeTrigger;
	ret = PhidgetTemperatureSensor_getMaxTemperatureChangeTrigger(h, &maxTemperatureChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return maxTemperatureChangeTrigger;
	}
	return maxTemperatureChangeTrigger;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_TemperatureSensorBase_getThermocoupleType(JNIEnv * env, jobject obj) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	PhidgetTemperatureSensor_ThermocoupleType thermocoupleType;
	ret = PhidgetTemperatureSensor_getThermocoupleType(h, &thermocoupleType);
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, ThermocoupleType_class, ThermocoupleType_getEnum_mid, thermocoupleType);
}

JNIEXPORT void JNICALL Java_com_phidget22_TemperatureSensorBase_setThermocoupleType(JNIEnv * env, jobject obj, jobject thermocoupleType) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetTemperatureSensor_setThermocoupleType(h, (PhidgetTemperatureSensor_ThermocoupleType)(*env)->CallIntMethod(env, thermocoupleType, ThermocoupleType_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW(ret);
		return;
	}
}

static void CCONV temperatureChange_handler(PhidgetTemperatureSensorHandle h, void *arg, double temperature) {
	jobject temperatureChangeEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((temperatureChangeEv = (*env)->NewObject(env, temperatureChangeEvent_class, temperatureChangeEvent_cons, obj, temperature)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireTemperatureChange_mid, temperatureChangeEv);
		(*env)->DeleteLocalRef(env, temperatureChangeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_TemperatureSensorBase_enableTemperatureChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativeTemperatureChangeHandler_fid, b);
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetTemperatureSensor_setOnTemperatureChangeHandler(h, b ? temperatureChange_handler : NULL, (void *)(uintptr_t) gr);
}
